{smcl}
{* 2017-08-13 Scott Long}{...}
{title:Title}

{p2colset 5 16 16 1}{...}
{p2col:{cmd:cdsave} {hline 2}}Create an ado file to changes the working directory
and set up the project environment. 2017-08-13{p_end}
{p2colreset}{...}

Add url()

Add user()

{title:General syntax}

{p 4 14 2}
{cmd:cdsave }[{cmd:cd}]{it:project} [ {cmd:,}
{opt n:ote(string)}
{opt auto:run(command-name)}
{opt data:path(path-name)}
{opt url(web-address)}
{opt user(string)}
{opt nos:lash} ]
{opt det:ails}
{opt replace} 
{p_end}

{title:Options}
{p2colset 5 18 19 0}
{synopt:{opt auto:run(command)}} is the command that will be run when
{cmd:cd*}{it:project} is run.
{p_end}
{p2colset 5 18 19 0}
{synopt:{opt data:path(path-name)}} is the path where data is stored. The
path is stored in the global {cmd:S_cddata}. 
{p_end}
{p2colset 5 18 19 0}
{synopt:{opt url(web-address)}} is a web address where data is stored. The
URL is stored in the global {cmd:S_cdurl}.
{p_end}
{p2colset 5 18 19 0}
{synopt:{opt noslash}} will not add an ending slash to paths or URLS.
{p_end}
{p2colset 5 18 19 0}
{synopt:{opt user(string)}} can be a path, web address, or other information.
The string is stored in the global {cmd:S_cduser}.
{p_end}
{p2colset 5 18 19 0}
{synopt:{opt det:ails}} will display the globals being created.
{p_end}
{p2colset 5 18 19 0}
{synopt:{opt n:ote(string)}} adds a note to describe the command being created.
{p_end}
{p2colset 5 18 19 0}
{synopt:{opt replace}} if the ado file exists, replace it.
{p_end}

{pstd}
Since names of the globals begin with
{cmd:S_} they are not removed by {cmd:clear all} or
{cmd:macro drop _all}. To remove then, {cmd:macro drop }{it:global-name}.

{title:Overview}

{pstd}
{cmd:cdsave} creates an ado file named {cmd:cd}{it:project}
that changes your working directory.
The commands are save in your PERSONAL directory so that any time
you enter a command created {cmd:cdsave} Stata will find the command
regardless of your current working directory.
The {cmd:cd*} ado file can optionally be used to
annotates what the ado file does, create a global with your data directory,
automatically run a command when the {cmd:cd}{it:project} is run, and other
things..

{pstd}
Note: The created commands start with {cmd:cd}. You can enter
the {it:project} with {cmd:cd} at the start of the name, or the {cmd:cd}
will be added automatically.

{pstd}
By creating multiple
{cmd:cd*} commands, you can easily
have different working directories for each
project with optional data locations for each project. The command
{cmd:cdlist} lists your {cmd:cd}{it:project} commands along with
the the working directory it sets or optionally lists the note you
added to describe the command. The command
{cmd:cdinfo} displays the {cmd:S_cd*} macros created by the command.
The command {cmd:cddrop} deletes selected {cmd:cd}{it:project} commands
from PERSONAL.

{title:Changing directories with cd* commands}

{pstd}
A simple example using two projects explains the most basic use of
{cmd:cd*} commands.
Suppose that project A uses working directory {cmd:d:/projectA/work},
while project B uses working directory {cmd:d:/projectB/work}.

{pstd}
Change your working directory to {cmd:d:/projectA/work}
To create the command {cmd:cdprojecta} to change the working directory
to {cmd:d:/projectA/work}:

{p 8 18 2}{cmd:. cdsave projecta}  {p_end}
{p 8 18 2}  command {cmd:cdprojecta saved in your personal directory    {p_end}

{pstd}
Since the command is saved in your personal directory, Stata will find it
when you run the command from any working directory:

{p 8 18 2}  {cmd:. cdprojecta}   {p_end}
{p 8 18 2}  {cmd:d:/projecta/work}    {p_end}

{pstd}
Next, change the working directory to {cmd:d:/projectB/work} 
and runn {cmd:cdsave projectb} to create {cmd:cdprojectb.ado} which changes
the working directory to {cmd:d:/projectB/work}

{title:Keeping track of {cmd:cd*} commands}

{pstd}
The {cmd:note()} option along the {cmd:cdlist} command help you keep track
of the commands you create. By default, {cmd:cdlist} lists the names of
all {cmd:cd*} commands and the working directory they set:

{p 8 18 2}  {cmd:. cdlist}                          {p_end}
{p 13 18 2} {cmd:cdaaa - d:/aaa/work/}              {p_end}
{p 13 18 2} {cmd:cdbbb - d:/bbb/work/}              {p_end}
{p 12 18 2} {cmd:cddesk - c:/Users/jslong/Desktop/} {p_end}
{p 11 18 2} {cmd:cdicpsr - d:/icpsr2017/work/}      {p_end}

{pstd}
If you prefer, you can use the {cmd:note()} option with {cmd:cdsave}
to document what the command does. For example, {cmd:cdsave aaa, note(Project A)}.
If a note has been saved with a command, it is listed instead
of the path for the working directory:

 {p 8 18 2}{cmd:. cdlist}                       {p_end}
{p 13 18 2}{cmd:cdaaa - Project A}              {p_end}
{p 13 18 2}{cmd:cdbbb - d:/bbb/work/}           {p_end}
{p 12 18 2}{cmd:cddesk - Desktop}               {p_end}
{p 11 18 2}{cmd:cdicpsr - ICPSR CDA Class 2017} {p_end}
{p 12 18 2}{cmd:cdtemp - scratch directory}     {p_end}

{pstd}
The {cmd:cdinfo} command and {cmd:cdlist, details} provide more detailed
information about other features used with creating comamnds.

{title:Using globals for datasets not in the working directory}

{pstd}
By default, the {cmd:use} command loads a dataset from the working
directory. If you want to load datasets from a different directory
or a web address, yu can use the globals create by the {cmd:cd*} commands--assuming
you added these options when creating the command. 

To load a dataset from the path specified by the {cmd:data()} option
in {cmd:cdsave},

{p 8 18 2} {cmd:use "${S_cddata}mydata", clear} {p_end}

{pstd}
To load a dataset from the URL specified by the {cmd:url()} option
in {cmd:cdsave},

{p 8 18 2} {cmd:use "${S_cdurl}mydata", clear} {p_end}

{pstd}
Three points about data paths.

{p 8 8 2}
1. By default paths and URLS are saved using {cmd:/}, not {cmd:\}.
The forward slash works in Win, Mac, and Unix.
{p_end}

{p 8 8 2}
2. {cmd:S_cddata} and {cmd:S_cdurl} ends with {cmd:/} so that
if the globals are not defined, 
{cmd: use "$}{cmd:{S_data}}{it:dataset}{cmd:" ,replace}
will still work. The {cmd:cdsave, noslash} option will not automatically
add an ending slash.
{p_end}

{p 8 8 2}
3. Quotes are needed when specifying the path in case there are spaces in
the path name.
{p_end}

{title:Automatically running a command for each project}

{pstd}
The {opt auto:run(command)} lets you specify a command that is run
as the last command in the {cmd:cd*} command.
This can be a Stata command or the name of an ado file you create
to initialize the project. As a simple example, suppose you always wanted
to load a specific dataset when you loaded your project. I can
create the command:

{p 8 18 2}  {cmd:. cdsave cdautoload, autorun(use binlfp4, clear)} {p_end}

{pstd}
To automatically load a dataset. Or, I can run a do file:

{p 8 18 2}  {cmd:. cdsave cdautoload, autorun(do myproject.do)} {p_end}

{title:Controlling the starting working directory}

{pstd}
You can create the command {cmd:cdstart} with {cmd:cdsave} and then
add {cmd:cdstart} to your {cmd:profile.do} to make the directory
set by {cmd:cmdstart} the starting directory in Stata.
You can replace the existing {cmd:cdstart} to have Stata begin in 
a different directory. 

{pstd}
In {cmd:profile.do} you can add {cmd:cdlist} to start Stata with a list
of the {cmd:cd*} commands. You can click on the command names, shown in blue,
to run the command.

{pstd}
These commands are suggested to prevent errors if any of the {cmd:cd*} commands
are not installed:

{p 8 18 2}{cmd:. capture noisily cdlist}{p_end}
{p 8 18 2}{cmd:. noisily di _new ". cdstart"}{p_end}
{p 8 18 2}{cmd:. capture noisily cdstart}{p_end}

{pstd}
This will list all available {cmd:cd*} commands and then change to the
directory specified in {cmd:cdstart}.


{title:Globals}

{pstd}
The {cmd:cd*} command use these globals:

{p2colset 8 19 12 0}
{synopt:{opt S_cdcmd}} name of {cmd:cd*} command.
{p_end}
{p2colset 8 19 12 0}
{synopt:{opt S_cdauto}} command to be automatically
run on completion of {cmd:cd*} command.
{p_end}
{p2colset 8 19 12 0}
{synopt:{opt S_cddata}} data directory path.
{p_end}
{p2colset 8 19 12 0}
{synopt:{opt S_cdurl}} web address.
{p_end}
{p2colset 8 19 12 0}
{synopt:{opt S_cduser}} any string.
{p_end}
{p2colset 8 19 12 0}
{synopt:{opt S_cdwd}} working directory set by {cmd:cd*} command.
{p_end}

{title:Citation}

{p 4 4 10}
J. Scott Long. 2017.
{it:A workflow for managing projects and working directories in Stata.}
{p_end}
{p 4 5 10}
{browse "http://www.indiana.edu/~jslsoc/"}
{p_end}
